bmap bmp_radar = <radar.tga>;
bmap bmp_splash = <splashscreen.bmp>;
bmap bmp_goal   = <survive.tga>;
bmap bmp_end		= <score.bmp>;


string mdl_monster_1_2 = <monster_1_2.mdl>;
string mdl_monster_1_1 = <monster_1_1.mdl>;
string mdl_mp5				 = <mp5.mdl>;
string muzzle_01			 = <muzzle_2.mdl>;
string schuss_01			 = <huelse.mdl>;

string str_temp;

entity* ptr_player;

sound waffe_1_sound = <wham.wav>;
var max_enemy = 0;
var muzzle_pos;
var var_punkt = 0;
var var_game_act = 0;

function fnc_waffe();
function explode_barrel(anzahl, range);

panel pn_splash
{
	bmap = bmp_splash;
	layer = 10;
	flags = visible;
	pos_x = 0;
	pos_y = 0;
}


panel pn_end
{
	bmap = bmp_end;
	pos_x = 0;
	pos_y = 0;
	layer = 10;
}


panel pn_goal
{
	bmap = bmp_goal;
	pos_x = 300;
	pos_y = 100;
	layer = 11;
}

sky sky_cube
{
	type = <sky_cube+6.tga>;
	flags = cube, visible;
	layer = 2;
	z = 30; // move 30 pixels upwards
}


function main()
{
	var var_save_mhandle;
	video_switch(8, 32, 1);
	randomize();
	tex_share = on;
	fps_max   = 30;
	sleep(2);
	level_load("level.wmb");
	wait(2);
	media_loop("Jbrock.mid", null, 100);
	var_save_mhandle = media_handle;
	var_game_act = 1;
	pn_splash.visible = off;
	Camera.clip_far	= 5000;
	sky_color.red = 0;
	sky_color.green = 0;
	sky_color.blue = 0;
	ent_create(mdl_mp5, nullvector, fnc_waffe);
	create_monster();
	pn_goal.visible = on;
	sleep(3);
	pn_goal.visible = off;
}


function fnc_exit()
{
	var_game_act = 0;
	pn_end.visible = on;
	while(key_any)	{	wait(1);	draw_text(str_for_num(str_temp, var_punkt), 500, 300, vector(0, 0, 100));	}
	while(!key_any)	{	wait(1);	draw_text(str_for_num(str_temp, var_punkt), 500, 300, vector(0, 0, 100));	}
	exit;
}


panel pn_radar
{
	bmap = bmp_radar;
	pos_x = 412;
	pos_y = 550;
	flags = visible, d3d;
	layer = 10;
}


action legs
{
	my.skill1 = 1;
	var get_pos;
	my.passable = on;
	while(you)
	{
		vec_for_vertex(get_pos, you, 113);
		vec_set(my.x, get_pos);
		my.pan += 100*time;
		wait(1);
	}
	ent_remove(me);
	return;
}


action monster
{
	my.skill1 = 1;
	var move_me;
	var my_pos;
	vec_for_vertex(my_pos, my, 113);
	ent_create(mdl_monster_1_2, my_pos, legs);
	my.z += 50;
	while(!me)	{	wait(1);	}
	wait(1);
	while(var_game_act == 1)
	{
		vec_diff(temp.x, my.x, ptr_player.x);
		temp.y = -temp.y;
		vec_rotate(temp.x, vector(ptr_player.pan-90, 0, 0));
		vec_scale(temp.x, 0.06);
		if(vec_length(temp.x)<100) 
		{
			draw_text("+", temp.x+508, temp.y+642, vector(0,0,255));
		}
		vec_for_vertex(my_pos, my, 113);
		// get the direction from the entity MY to the entity YOU
		vec_set(temp,ptr_player.x); 
		vec_sub(temp,my.x);
		vec_to_angle(my.pan,temp); // now MY looks at YOU
		my.tilt = 0;
		my.roll = 0;
		my.pan += 180;
		move_me.x = -4 * time;
		ent_move(move_me, nullvector);
		if(vec_dist(ptr_player.x, my.x) < 50)
		{
			fnc_exit();
		}
		wait(1);
	}
}


function create_monster()
{
	var random_pos;
	var circle;
	var counter = 5;
	while(var_game_act == 1)
	{	
		sleep(random(counter/10)+counter/10);
		circle = random(360);
		vec_set(random_pos, vector(sin(circle)*1000, cos(circle)*1000, 0)); // HIER WEITER MACHEN!
		ent_create(mdl_monster_1_1, random_pos, monster);
		wait(1);
	}
}



function camera_move()
{
	while(1)
	{
		vec_set(camera.x, ptr_player.x);
		camera.pan = ptr_player.pan;
		camera.tilt = ptr_player.tilt;
		wait(1);
	}
}


action player_act
{
	ptr_player = me;
	while(!ptr_player)	{	wait(1);	}
	camera_move();
	my.invisible = on;
	my.z += 20;
	while(1)
	{
		my.tilt = min(89, max(my.tilt, -70));
		my.pan  -= 10 * mouse_force.x;
		my.tilt += 10 * mouse_force.y;
		wait(1);
	}
}



function set_weapon_pos()
{
	var move_weapon = 0;
	var pos_weapon[3] = 0,0,0;
	while(1)
	{
		vec_set(my.x, camera.x);
		my.pan = camera.pan-90;
		my.tilt = camera.roll;
		my.roll = camera.tilt;
		wait(1);
	}
}



function muzzle_fnc
{
	my.bright = on;
	my.flare = on;
	my.overlay = on;
	my.unlit = on;
	my.alpha=50;
	my.invisible=off;
	my.passable = on;
	vec_set(my.pan, camera.pan);
	while(my.alpha>20)
	{
		my.lightrange = 200;
		my.red = 256;
		my.green = 256;
		my.blue = 128;
		my.light = on;
		vec_set(my.pan, camera.pan);
		my.alpha=max(0, my.alpha-time*40);
		wait(1);
	}
	my.invisible=on;
	ent_remove(me);
}



function waffe_damage
{
	if(event_type == event_entity)
	{
		if(you && you.skill1 == 1)
		{
			explode_barrel(10, 100);
			wait(1);
			ent_remove(you);
			var_punkt += 1;
			return;
		}
		wait(1);
		ent_remove(me);
	}
	if(event_type == event_block)
	{
		wait(1);
		ent_remove(me);
	}
}




function waffe_schuss_func
{
	var waffe_1_schuss_bahn[3];

	my.push							= -1;
	my.enable_impact 		= on;
	my.enable_entity 		= on;
	my.enable_block			= on;
	my.enable_stuck			= on;
	my.event 						= waffe_damage;

	my.invisible 				= off;

	my.pan 							= camera.pan;   
	my.tilt 						= camera.tilt;   
	my.roll 						= camera.roll;

	while(1)
	{
		trace_mode = IGNORE_ME;
		temp.x = 5000; //Abstand nach vorne
		temp.y = 0;
		temp.z = 0;
		vec_rotate(temp,camera.pan); //nun ists relativ zur kamerablickrichtung
		vec_add(temp,camera.x); //und nun ist es der richtige, absolute vektor
		trace(camera.x,temp); //nun von camerapos zur erechneten tracen

		waffe_1_schuss_bahn.x = 1000*time;
		move_mode = ignore_me + ignore_sprites + ignore_passable;
		ent_move(waffe_1_schuss_bahn,nullvector);
		wait(1);
	}	
}


function fnc_waffe()
{
	while(me == NULL)	{	wait(1);	}
	set_weapon_pos();
	my.passable = on;
	while(var_game_act == 1)
	{
		while(mouse_left == 1)
		{
			vec_for_vertex(muzzle_pos, me, 784);
			ent_create(muzzle_01, muzzle_pos, muzzle_fnc);
			ent_create(schuss_01, muzzle_pos, waffe_schuss_func);
			snd_play(waffe_1_sound, 10, 0);
			wait(5);
		}
		wait(1);
	}
}






function drum_explode() // your function name.
{
	MY.PASSABLE = ON; // passable pieces
	MY.SCALE_X = 1; // scale x y and z going down.
	MY.SCALE_Y = 1;
	MY.SCALE_Z = 1;
	MY.FLARE = ON; // making it very bright like a glow
	MY.LIGHT = ON; // bright
	MY.BRIGHT = ON; // giving more light
	MY.BLEND = ON; // blend into everything else.
	MY.LIGHTRED = 100; // very red for fire 255 bright 0 black
	MY.LIGHTGREEN = 0; // medium blue
	MY.LIGHTBLUE = 0; // no blue
	MY.LIGHTRANGE = 50; // range of 100 change to distance of shot.
	my.PAN = 360;
	my.TILT = 360;
	temp.Z = 105; //105 Unit exploding range
	temp = 10000;

	my.nofog = on; 

	WHILE(my.frame<=16)
	{
		MY.LIGHTRANGE += 2;
		my.frame+=TIME;
		MY.Z += 6*TIME;
		wait(1);
	}
	my.invisible = on; // turning the pieces off and all of the explode.
	WHILE(MY.LIGHTRANGE > 0)
	{
		MY.LIGHTRANGE -= 20; // turning the range down.
		wait(1);
	}
	while(me != NULL)
	{
		MY.LIGHTRANGE = 0;
		ent_remove(my); // remove all of the function.
		return;
		wait(1);
	}
}



function explode_barrel(anzahl, range)
{
	var counter = 0;
	var position[3];
	vec_set(position.x, my.x);
	my.invisible = on;
	temp.pan = 360; 	
	temp.tilt = 360; 	
	temp.z = range; 	
	scan_entity (my.x, temp); 	
	while(counter < anzahl)
	{
		ent_create("blood.tga", position.x, drum_explode);
		counter += 1;
		wait(1);
	}
	return;
}